import os, pygame
from pygame.locals import *

#functions to create our resources
def load_image(name, colorkey=None):
    fullname = os.path.join('Data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

class AlienEnemy(pygame.sprite.Sprite):
    """ An alien enemy, beware! """
    def __init__(self, xy, floor):
        pygame.sprite.Sprite.__init__(self)
        self.image, self.rect = load_image('alienEnemy_stand1.gif', -1)
        self.stand_image = self.image
        self.stand_imageFlip = pygame.transform.flip(self.stand_image, 1, 0)

        self.runLeft = []
        runLeft1, null = load_image('ninja_walk1.gif', -1)
        runLeft2, null = load_image('ninja_walk2.gif', -1)
        runLeft3, null = load_image('ninja_walk3.gif', -1)
        self.runLeft.append(runLeft1)
        self.runLeft.append(runLeft2)
        self.runLeft.append(runLeft3)
        self.runLeft.append(runLeft2)

        self.runRight = []
        runRight1 = pygame.transform.flip(runLeft1, 1, 0)
        runRight2 = pygame.transform.flip(runLeft2, 1, 0)
        runRight3 = pygame.transform.flip(runLeft3, 1, 0)
        self.runRight.append(runRight1)
        self.runRight.append(runRight2)
        self.runRight.append(runRight3)
        self.runRight.append(runRight2)

        self.cFrame = 0
        self.rect.topleft = xy
        self.level = floor
        self.facingRight = False

    def update(self, player):
        if self.facingRight == False:
            x,y = self.rect.topleft
            x = x - 2
            self.rect.topleft = (x,y)
            if ( x < 5 ):
                self.turnDirection()
        else:
            x,y = self.rect.topleft
            x = x + 2
            self.rect.topleft = (x,y)
            if ( x > 605 ):
                self.turnDirection()

        if player.level == self.level:
            px,py = player.rect.topleft
            ax,ay = self.rect.topleft
            if px > ax and self.facingRight == False:
                self.turnDirection()
            elif px < ax and self.facingRight == True:
                self.turnDirection()

    def turnDirection(self):
        self.facingRight = not self.facingRight
        if self.facingRight == True:
            self.image = self.stand_imageFlip
        else:
            self.image = self.stand_image

