import os, pygame
from pygame.locals import *

#functions to create our resources
def load_image(name, colorkey=None):
    fullname = os.path.join('Data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

def load_sound(name):
    class NoneSound:
        def play(self): pass
    if not pygame.mixer or not pygame.mixer.get_init():
        return NoneSound()
    fullname = os.path.join('Music', name)
    try:
        sound = pygame.mixer.Sound(fullname)
    except pygame.error, message:
        print 'Cannot load sound:', fullname
        raise SystemExit, message
    return sound

class Ladder(pygame.sprite.Sprite):
    """ Ladder allows people to move around """
    def __init__(self, xy, flip):
        pygame.sprite.Sprite.__init__(self)
        self.image, self.rect = load_image('ladder1.gif', -1)
        self.rect.topleft = xy
        self.facingRight = flip
        if self.facingRight == False: #We are not facing right
            self.image = pygame.transform.flip(self.image, 1, 0)

    def walkTo(self):
        null = 0 #gotta change

    def activate(self):
        return self.rect.topleft

    def name(self):
        return "ladder"

class ControlBox(pygame.sprite.Sprite):
    """ Exit that we go through! """
    def __init__(self, xy):
        pygame.sprite.Sprite.__init__(self)
        self.boxSound = load_sound('dloopNoise.wav')
        self.image, self.rect = load_image('controlBox2.gif', -1)
        self.image2, null = load_image('controlBox1.gif', -1)
        self.rect.topleft = xy
        self.cName = "controlBox"

    def update(self):
        null = 0 # updating picture or something goes here

    def activate(self):
        if self.cName == "controlBox":
            self.cName = "deadBox"
            self.image = self.image2
            self.boxSound.play()
        return self.rect.topleft

    def name(self):
        return self.cName

class Exit(pygame.sprite.Sprite):
    """ Exit that we go through! """
    def __init__(self, xy):
        pygame.sprite.Sprite.__init__(self)
        self.exitSound = load_sound('exitNoise.wav')
        self.image, self.rect = load_image('exit2.gif')
        self.image2, null = load_image('exit1.gif')
        self.rect.topleft = xy
        self.cName = "myExit"

    def update(self):
        null = 0 # updating picture or something goes here

    def activate(self):
        return self.rect.topleft

    def Complete(self):
        self.cName = "Complete"
        self.image = self.image2
        self.exitSound.play()

    def name(self):
        return self.cName
