import os, pygame
from pygame.locals import *

#functions to create our resources
def load_image(name, colorkey=None):
    fullname = os.path.join('Data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

#classes for our game objects
class Ninja(pygame.sprite.Sprite):
    """Control your Ninja!"""
    def __init__(self, xy):
        pygame.sprite.Sprite.__init__(self) #call Sprite initializer
        self.image, self.rect = load_image('ninja_stand1.gif', -1)
        self.stand_image = self.image
        self.stand_imageFlip = pygame.transform.flip(self.stand_image, 1, 0)

        self.runLeft = []
        runLeft1, null = load_image('ninja_walk1.gif', -1)
        runLeft2, null = load_image('ninja_walk2.gif', -1)
        runLeft3, null = load_image('ninja_walk3.gif', -1)
        self.runLeft.append(runLeft1)
        self.runLeft.append(runLeft2)
        self.runLeft.append(runLeft3)
        self.runLeft.append(runLeft2)

        self.runRight = []
        runRight1 = pygame.transform.flip(runLeft1, 1, 0)
        runRight2 = pygame.transform.flip(runLeft2, 1, 0)
        runRight3 = pygame.transform.flip(runLeft3, 1, 0)
        self.runRight.append(runRight1)
        self.runRight.append(runRight2)
        self.runRight.append(runRight3)
        self.runRight.append(runRight2)

        self.cFrame = 0
        
        self.rect.topleft = xy
        self.movement = 0 #standing
        self.face = 0 # facing left

        # debug what level are we on?
        self.level = 0

    def update(self):
        "move the fist based on the mouse position"
        if self.movement == 0: # standing
            if self.face == 0:
                self.image = self.stand_image
            elif self.face == 1:
                self.image = self.stand_imageFlip
        elif self.movement == 1: # move left
            x,y = self.rect.topleft
            if x > 5:
                x = x - 3
                self.rect.topleft = (x,y)
            if self.cFrame < 39:
                self.cFrame = self.cFrame + 1
            else:
                self.cFrame = 0
            self.image = self.runLeft[self.cFrame / 10]
            
        elif self.movement == 2: # move right
            x,y = self.rect.topleft
            if x < 603:
                x = x + 3
                self.rect.topleft = (x,y)
            if self.cFrame < 39:
                self.cFrame = self.cFrame + 1
            else:
                self.cFrame = 0
            self.image = self.runRight[self.cFrame / 10]

    def moveLeft(self):
        self.movement = 1
        self.face = 0

    def moveRight(self):
        self.movement = 2
        self.face = 1

    def stop(self):
        self.movement = 0

    def aim(self):
        aimState = 1

    def attack(self):
        gunorSword = 1

    def checkAction(self, action):
        actionName, actionVar = action
        if actionName == "warp":
            self.rect.topleft = actionVar
            x,y = actionVar
            self.level = (y - 42) / 64
            print "Warping now capt'n! We're now on Level " + str(self.level)
        elif actionName == "ladder":
            print "Ladder at " + str(actionVar)
            x,y = self.rect.topleft
            y = y - 64
            self.rect.topleft = (x,y)
            self.level = self.level - 1
        elif actionName == "myExit":
            print "Exit at " + str(actionVar)
        elif actionName == "Complete":
            print "Completed Level at " + str(actionVar)
        elif actionName == "controlBox":
            print "Control Box at " + str(actionVar)
        elif actionName == "deadBox":
            print "Dead Box at " + str(actionVar)

